#include "./sticky.h"
#define C_H_VALUE 6 /* (Casertano & Hut 1985 's j) */

void force_host_with_nbl(x,m,eps,a,pot,n,h2,nblist,nbn,min_nbn)  
        REAL x[NMAX][DIM];
        REAL m[NMAX];
        REAL eps;
        REAL a[NMAX][DIM];
        REAL pot[NMAX];
        int n;
        REAL h2;
        int nblist[NMAX][NBMAX];
        int nbn[NMAX];
        int min_nbn;
{
        int i,j,d,k;
        REAL r2, r3inv,rinv,eps2;
        REAL dx[DIM];  


        for(j=0;j<n;j++){
          for(d=0;d<DIM;d++){
            a[j][d] = 0.0;
            a[j][d] = 0.0;
          }
          pot[j] = 0.0;  
        }
        eps2 = eps*eps;   

        for(i=0;i<n;i++){
          nblist[i][0] = i;
          for(k=1;k<NBMAX;k++) nblist[i][k] = 0;
          nbn[i] = 1;
        }

        for(i=0;i<n-1;i++){
          for(j=i+1;j<n;j++){
            if(i!=j){
              r2 = eps2;
              for(d=0;d<DIM;d++){
                dx[d] = x[j][d] - x[i][d];
                r2 += dx[d] * dx[d];
              }
              if(r2<h2){ 
                nblist[i][nbn[i]]=j;
                nblist[j][nbn[j]]=i;
                nbn[i]++;
                nbn[j]++;
              }
/*          
              r3inv = 1.0 / (sqrt(r2) * r2);
              rinv = r3inv * r2;
              for(d=0;d<DIM;d++){
                a[i][d] += m[j] * r3inv * dx[d];
                a[j][d] += - m[i] * r3inv * dx[d];
              }
              pot[i] += m[j]*rinv;
              pot[j] += m[i]*rinv;
*/
            }
          }
        }
/*printf("h2 = %e\n",h2);
for(j=0;j<n;j++)printf("i %d nbn %d\n",j,nbn[j]);
*/
        for(i=0;i<n;i++) pot[i] *= -1;
        for(i=0;i<n;i++){
          REAL newh2;
          newh2 = h2;
          while(nbn[i]<min_nbn){
            for(j=1;j<nbn[i];j++) nblist[i][j] = 0; 
            nbn[i]= 1; 
            newh2 *= 4.0;
            for(j=0;j<n;j++){
              if(i!=j){
                r2 = eps2;
                for(d=0;d<DIM;d++){
                  dx[d] = x[j][d] - x[i][d];
                  r2 += dx[d] * dx[d];
                }
                if(r2<newh2){ 
                  nblist[i][nbn[i]]=j;
                  nbn[i]++;
                }
              }
            }
          }
        }

/*printf("rinv= %e\n",rinv);*/
/*printf("eps2 = %e\n",eps2);   */
/*printf("x[%d][%d]=%e, x[%d][%d]=%e\n",j,d,x[j][d],i,d,x[i][d]);*/
/*for(i=0;i<n;i++)printf("pot = %e \n",pot[i]);*/
}

void sort_nblist(xi,x,nblists,nbns)
REAL xi[DIM];
REAL x[NMAX][DIM];
int nblists[NBMAX];
int nbns;
{
	int i,j;
	REAL r2[NBMAX];

	for(j=0;j<nbns;j++){
	  r2[j] = (xi[0]-x[nblists[j]][0])*(xi[0]-x[nblists[j]][0])
	  	+ (xi[1]-x[nblists[j]][1])*(xi[1]-x[nblists[j]][1])
	  	+ (xi[2]-x[nblists[j]][2])*(xi[2]-x[nblists[j]][2]);
	}

/*	for(j=0;j<nbns;j++)printf("%5.2e ",r2[j]);
	printf("\n");
*/	
	sort_two_values(0,nbns-1,r2,nblists);

/*	for(i=0;i<nbns-1;i++){
	  for(j=i+1;j<nbns;j++){
	    if(r2[i]>r2[j]){
	      REAL tmpr2;
              int tmpnblist;
	      tmpr2 = r2[i];
	      r2[i] = r2[j];
	      r2[j] = tmpr2;
	      tmpnblist = nblists[i];
	      nblists[i] = nblists[j];
	      nblists[j] = tmpnblist;
	    }
	  }
	}
*/
/*	for(j=0;j<nbn;j++)printf("%5.2e ",r2[j]);
	printf("\n");
*/
}

void obtain_individual_density(x,m,nblist,rho)
REAL x[NMAX][DIM];
REAL m[NMAX];
int nblist[NBMAX];
REAL *rho;
{
/* in nblist[0], i itself is stored. */

	REAL total_mass=0.0,r2;
	int i;
	
	for(i=0;i<=(C_H_VALUE-1);i++) total_mass += m[nblist[i]]; 

	r2 = (x[nblist[0]][0]-x[nblist[C_H_VALUE]][0])*(x[nblist[0]][0]-x[nblist[C_H_VALUE]][0]) 
	   + (x[nblist[0]][1]-x[nblist[C_H_VALUE]][1])*(x[nblist[0]][1]-x[nblist[C_H_VALUE]][1]) 
	   + (x[nblist[0]][2]-x[nblist[C_H_VALUE]][2])*(x[nblist[0]][2]-x[nblist[C_H_VALUE]][2]) ;

	*rho = 3.0/(4.0*PI)*total_mass/(r2*sqrt(r2));
}

REAL interpolate(mr0,r20,mr1,r21,mlagr)
REAL mr0,mr1;
REAL r20,r21;
REAL mlagr;
{
	REAL r0,r1;
	REAL a,rlagr;  

	r0 = sqrt(r20);
	r1 = sqrt(r21);

	a = pow((mlagr-mr0)/(mr1-mr0),1.0/3.0);
	rlagr =  r0 + (r1-r0)*a;

	return rlagr;
}		
static int first_flag=1;

void radius(time,x,v,m,n,epsv)
REAL time;
REAL x[NMAX][DIM];
REAL v[NMAX][DIM];
REAL m[NMAX];
int n;
REAL epsv;
{
	REAL eps = 0.0;
	REAL a[NMAX][DIM];
	REAL aco[NMAX][DIM];
	REAL ace[NMAX][DIM];
	REAL pot[NMAX],r2[NMAX];
	REAL h2;
#ifdef ONLYGRAPE
#ifdef USEGRAPE3
	static int nblist[24][NBMAX];
	static int nbn[24];
#endif
#ifdef USEGRAPE2AF
	static int nblist[NBMAX];
	static int nbn;
#endif
#endif
#ifdef ONLYHOST
	static int nblist[NMAX][NBMAX];
	static int nbn[NMAX];
#endif
#ifdef USEHARP2
/*	static int nblistt[NMAX][NBMAX];
	static int nbnt[NMAX];*/
	static int nblist[NBMAX];
	static int nbn;
#endif
	int min_nbn;
	int i,j,k,d;
	REAL rho[NMAX],rho2;
	REAL cvod[DIM];
	REAL tmp1,tmp2,tmp3a,tmp4a;
	REAL tmp3[DIM],tmp4[DIM];
	REAL rcore,rcore2; 
	REAL mcore,vcore;
	int ncore,index[NMAX];
	REAL mlagr[20];
	REAL mr[NMAX],rlagr[20];
	REAL sigma0,rho0,rcore0,rho0ch;
	REAL rmi[16],mmean,mevl,mmeant,v_ratio,i2dot,aniso;
	REAL amx,amy,amz,omegag;
	REAL vtermk,vtermv,vtermco,vtermce;
	REAL rhodw, rhod2w,potc;
        int nchips,nn;
        int get_neighbor_list();
        int read_neighbor_list();
        int max_neighbor_number();
	FILE *fp1;
          
	REAL totalm;
	REAL rtidal,gyxy;
	REAL omegag2=0.0;
	int proflag;
	
	REAL cod[DIM];

      	int ncl,nch;
        REAL vc2l,vc2h;

	totalm = 1.0;
	rtidal = 100000.0;
/*********  setup for GRAPE ********************/

	h2=8.0/pow((double)n,2.0/3.0);
	min_nbn=8;

	for(j=0;j<n;j++){
          for(d=0;d<DIM;d++)a[j][d] = 0.0;
          pot[j] = 0.0;
        }

#ifdef ONLYGRAPE

#ifdef USEGRAPE3 
        set_scales(1.0/1024,m[0]);
        nchips = number_of_available_chips();
        set_eps2(eps*eps);
#endif    
        set_n(n);
        for(j=0;j<n;j++){
          set_xj(j,x[j]);
          set_mj(j,m[j]);
        }

/*********  obtain neighbor list using GRAPE-3 ************/
/*********  (including recalculation until nbn > min_nbn **/

#ifdef USEGRAPE3
#ifdef RIESLING
	nchips = 1;
#endif
        for(i=0;i<n;i+=nchips){
          int no_flag,maxnbn,rnbn;
          int no_list[24];
          REAL newh2;

          newh2 = h2; 
          for(k=0;k<nchips;k++) set_h2(newh2,k);
#ifdef RIESLING
	  for(k=nchips;k<12;k++) set_h2(0.0,k);
#endif
         nn = nchips;
          if(i+nn > n) nn = n - i;
          for(k=0;k<nn;k++) no_list[k] = 0;
          calculate_force_on_x(x[i],a[i],pot+i,nn);
	  rnbn = read_neighbor_list();
	  maxnbn = max_neighbor_number() - 5;
          while(rnbn>= maxnbn){
	    newh2 *= 0.25;
            for(k=0;k<nchips;k++) set_h2(newh2,k);
	    calculate_force_on_x(x[i],a[i],pot+i,nn);
	    rnbn = read_neighbor_list();
/*printf("%d r,mnbn = %d %d ",i+k,rnbn,maxnbn);*/
	  }
          for(k=0;k<nn;k++){
            nbn[k]=get_neighbor_list(k,nblist[k]);
            if(nbn[k]<min_nbn) no_list[k] = 1;
          }
          no_flag = 0;
          for(k=0;k<nn;k++) no_flag = (no_flag||no_list[k]);
        
          while(no_flag>0){
            newh2 *= 2.0;
	    do{
	      newh2 *=0.8;
              for(k=0;k<nn;k++){
	        if(no_list[k]==1){
/*	          printf("nbn %d %d ",i+k,nbn[k]); */
		  set_h2(newh2,k);
                }else{
		  set_h2(0.0,k);
	        }
	      }
              calculate_force_on_x(x[i],a[i],pot+i,nn);
              rnbn = read_neighbor_list();
	    }while(rnbn > maxnbn);
            for(k=0;k<nn;k++){
              if(no_list[k]==1){
                nbn[k]=get_neighbor_list(k,nblist[k]);
/*	        printf("nbn %d %d \n",i+k,nbn[k]); */
                if(nbn[k]>=min_nbn) no_list[k] = 0;
              }
            }
            no_flag = 0; 
            for(k=0;k<nn;k++) no_flag = (no_flag||no_list[k]);
          }

/******** calculate individual density *****************************/

	  for(k=0;k<nn;k++){
	    sort_nblist(x[i+k],x,nblist[k],nbn[k]);
	    if(nblist[k][0]!=(i+k)){
	      int jn;
	      printf("%d %d %d NB error !!!!!!\n",nblist[k][0],i+k,nbn[k]);
/*	      for(jn=0;jn<nbn[k];jn++)printf("%d ",nblist[k][jn]);*/
/*	      printf("\n");	*/
	    }
	    obtain_individual_density(x,m,nblist[k],&rho[i+k]);
/*printf("i=%4d nbn %d nb = %4d %4d %4d %4d %4d %4d\n",i+k,nbn[k],nblist[k][0],nblist[k][1],nblist[k][2],nblist[k][3],nblist[k][4],nblist[k][5]);
*/	  }  
        }   
#endif

#ifdef USEGRAPE2AF
         for(i=0;i<n;i++){
          int no_flag;
          REAL newh2;
	  int ii;
	  REAL r2i,tmi;

	  set_h2(h2,k);
          let_grape2a_calculate_force_on_x(x[i],i,eps,a[i],pot+i);
          nbn=get_neighbor_list(nblist,n);
          if(nbn<min_nbn) no_flag = 1;
      
          newh2 = h2; 
          while(no_flag>0){
            newh2 *= 4.0;
            set_h2(newh2);
            let_grape2a_calculate_force_on_x(x[i],i,eps,a[i],pot+i);
            nbn=get_neighbor_list(nblist,n);	
            if(nbn>=min_nbn) no_flag = 0;
          }

/******** calculate individual density *****************************/

	  sort_nblist(x[i],x,nblist,nbn);
	  if(nblist[0]!=i){
	    int jn;
	    printf("%d %d %d NB error !!!!!!\n",nblist[0],i,nbn);
	  }
	  obtain_individual_density(x,m,nblist,&rho[i]);
/*printf("i=%4d nb = %4d %4d %4d %4d %4d %4d\n",i,nblist[0],nblist[1],nblist[2],nblist[3],nblist[4],nblist[5]);
*/
        }   
#endif
#endif

#ifdef ONLYHOST
	force_host_with_nbl(x,m,eps,a,pot,n,h2,nblist,nbn,min_nbn);
	for(i=0;i<n;i++){
/*	printf("i=%d nbn= %d\n",i,nbn[i]); */
/*printf("i=%4d nb = %4d %4d %4d %4d %4d %4d\n",i,nblist[i][0],nblist[i][1],nblist[i][2],nblist[i][3],nblist[i][4],nblist[i][5]);*/
	   sort_nblist(x[i],x,nblist[i],nbn[i]);
	   obtain_individual_density(x,m,nblist[i],&rho[i]);
	}
#endif

#ifdef USEHARP2

/**** (for comparison)
	force_host_with_nbl(x,m,eps,a,pot,n,h2,nblistt,nbnt,min_nbn);
	for(i=0;i<n;i++){
	printf("i=%d nbn= %d\n",i,nbnt[i]); 
printf("i=%4d nb = %4d %4d %4d %4d %4d %4d\n",i,nblist[i][0],nblist[i][1],nblist[i][2],nblist[i][3],nblist[i][4],nblist[i][5]);
	   sort_nblist(x[i],x,nblistt[i],nbnt[i]);
	   obtain_individual_density(x,m,nblistt[i],&rho[i]);
if(i<10)printf("i=%4d nb = %4d %4d %4d %4d %4d %4d %e\n",i,nblistt[i][0],nblistt[i][1],nblistt[i][2],nblistt[i][3],nblistt[i][4],nblistt[i][5],rho[i]);
	}
******/
        proflag=0;
        hold_grape(proflag);

        set_n(n);
        for(j=0;j<n;j++){
          set_xj(j,x[j]);
          set_mj(j,m[j]);
        }
	set_eps2(0,eps*eps);

        for(i=0;i<n;i++){
          int no_flag;
          REAL newh2,xtmp[4][DIM];
	  int ii,d;
	  REAL r2i,tmi,ttime=0.0;;

	  for(d=0;d<DIM;d++) xtmp[0][d] = x[i][d]; 
	  for(d=0;d<DIM;d++) xtmp[1][d] = x[i][d]; 
	  for(d=0;d<DIM;d++) xtmp[2][d] = x[i][d]; 
	  for(d=0;d<DIM;d++) xtmp[3][d] = x[i][d]; 

	  set_h2(0,h2);
	  set_h2(2,0.0);
          newh2 = h2; 
	  play_harp2(2,xtmp[0],xtmp[0],&ttime,a[i],a[i],pot+i);
	  while(read_neighbor_list()==1){
	    newh2 *= 0.5;
/*	    printf("nb full 1 i %d %e\n",i,newh2);*/
	    set_h2(0,newh2);
	    play_harp2(2,xtmp[0],xtmp[0],&ttime,a[i],a[i],pot+i);
	  }	    
          nbn=get_neighbor_list(0,nblist);
          if(nbn<min_nbn) no_flag = 1;
/*printf("i nbn %d %d\n",i,nbn);       */
          while(no_flag>0){
            newh2 *= 2.0;
            set_h2(0,newh2);
	    play_harp2(1,xtmp[0],xtmp[0],&ttime,a[i],a[i],pot+i);
	    while(read_neighbor_list()==1){
	      newh2 *= 0.75;
/*	      printf("nb full 2 i %d\n",i);*/
	      set_h2(0,newh2);
	      play_harp2(2,xtmp[0],xtmp[0],&ttime,a[i],a[i],pot+i);
	    }	    
            nbn=get_neighbor_list(0,nblist);	
            if(nbn>=min_nbn) no_flag = 0;
/*printf("h2 nbn %e %d %d %d %e\n",newh2,nbn,nblist[0],nblist[1],a[i][0]);	*/
          }

/******** calculate individual density *****************************/

/*	  printf("i %d nb ",i);
	  for(j=0;j<nbn;j++)printf("%d ",nblist[j]);
	  printf("\n");
*/
	  sort_nblist(x[i],x,nblist,nbn);
	  if(nblist[0]!=i){
	    int jn;
	    printf("%d %d %d NB error !!!!!!\n",nblist[0],i,nbn);
	  }
	  obtain_individual_density(x,m,nblist,&rho[i]);
/*if(i<10)printf("i=%4d nb = %4d %4d %4d %4d %4d %4d rho %e\n",i,nblist[0],nblist[1],nblist[2],nblist[3],nblist[4],nblist[5],rho[i]);
*/        }   

	free_grape();
#endif

/******** calculate the centre of density (cod[3])*******************************/

	tmp1 = 0.0;	
	for(k=0;k<DIM;k++) tmp3[k] = 0.0;  
	for(k=0;k<DIM;k++) tmp4[k] = 0.0;  
	for(i=0;i<n;i++){
	  tmp1 += rho[i];
	  for(k=0;k<DIM;k++) tmp3[k] += rho[i]*x[i][k]; 
	  for(k=0;k<DIM;k++) tmp4[k] += rho[i]*v[i][k]; 
	}
	for(k=0;k<DIM;k++) cod[k] = tmp3[k]/tmp1;
	for(k=0;k<DIM;k++) cvod[k] = tmp4[k]/tmp1;

	printf("center   of density %e %e %e\n",cod[0],cod[1],cod[2]);
/*	printf("v center of density %e %e %e\n",cvod[0],cvod[1],cvod[2]);*/

/********* calculate the distance to the density centre ******************/

	for(i=0;i<n;i++) {
	  r2[i] = (x[i][0]-cod[0])*(x[i][0]-cod[0])
		+ (x[i][1]-cod[1])*(x[i][1]-cod[1])
		+ (x[i][2]-cod[2])*(x[i][2]-cod[2]);
	}

/********* calculate density radius (core radius)(rcore) ***********************/

	tmp1 = 0.0;
	tmp2 = 0.0;
	tmp3a = 0.0;
	tmp4a = 0.0;  
	for(i=0;i<n;i++) {
	  rho2 = rho[i]*rho[i];
	  tmp1 += rho2*r2[i];
	  tmp2 += rho2;
	  tmp3a += rho[i];
	  tmp4a += rho[i]*rho2;
	} 
	rcore2 = tmp1/tmp2;
	rcore = sqrt(rcore2);

	rhodw = tmp2/tmp3a;
	rhod2w = tmp4a/tmp2;

/******** calculate mass, rms velocity, and number within core radius(mcore,ncore,vcore)***/ 

	mcore = 0.0;
	ncore = 0;
	vcore = 0.0;
	for(i=0;i<n;i++){
	  if(r2[i]<=rcore2){ 
	    mcore += m[i];
	    ncore++;
	    vcore += v[i][0]*v[i][0]+v[i][1]*v[i][1]+v[i][2]*v[i][2];   
	  }
	}
	vcore = sqrt(vcore/(REAL)ncore);

	if(1){
         int nl=0,nctmp;
         REAL vc2tmp;
 
         for(i=0;i<n;i++){
           if(m[i]==m[0]) nl++;
         }
         ncl = 0;
         vc2l = 0.0;
         for(i=0;i<nl;i++){
           if(r2[i]<=rcore2){ 
            ncl++;
             vc2l += v[i][0]*v[i][0]+v[i][1]*v[i][1]+v[i][2]*v[i][2];   
           }
         }
 /*      printf("core t %g ncl %d v2cl %e ",time,nctmp,vc2tmp/nctmp);*/
         nch = 0;
         vc2h = 0.0;
         for(i=nl;i<n;i++){
           if(r2[i]<=rcore2){ 
             nch++;
             vc2h += v[i][0]*v[i][0]+v[i][1]*v[i][1]+v[i][2]*v[i][2];   
           }
         }
 /*      printf("nch %d v2ch %e\n",nctmp,vc2tmp/nctmp);*/
       }
 
	rho0ch = (3.0/(4.0*PI))* mcore / (rcore2*sqrt(rcore2));
	
/******** sort particle *************************/

	for(i=0;i<n;i++) index[i] = i;

	sort_particles(0,n-1,r2,index);
	
/*for(i=0;i<n;i++) printf("%d %e \n",i,r2[index[i]]);*/

/********* calculate lagrangean radius (rlagr[])******/
/* must be changed in the case of TIDAL_CUTOFF !!!*/

	mlagr[0] = 0.01;
	mlagr[1] = 0.02;
	mlagr[2] = 0.05;
	mlagr[3] = 0.1;
	mlagr[4] = 0.2;
	mlagr[5] = 0.5;
	mlagr[6] = 0.75;
	mlagr[7] = 0.9;
	mlagr[8] = 0.95;
	mlagr[9] = 0.99;
	mlagr[10] = 1.0;

	k=0;
	for(i=0;i<n;i++){
	  if(i==0){
	    mr[index[i]] = m[index[i]]/ totalm;
	  }else{
	    mr[index[i]] = mr[index[i-1]] + m[index[i]]/ totalm;
	  }
	  while((mr[index[i]] > mlagr[k])&&(k<10)){
/*printf("i mr mlagr %d %e %e \n",i,mr[index[i]],mlagr[k]);*/
	    if(i==0){
	      REAL center = 0.0;
	      rlagr[k] = interpolate(center,center,mr[index[i]],r2[index[i]],mlagr[k]);
	    }else{
	      rlagr[k] = interpolate(mr[index[i-1]],r2[index[i-1]],mr[index[i]],r2[index[i]],mlagr[k]);
	    }
	    k++;

/*	    mr[index[i+1]] = mr[index[i]] + m[index[i+1]]/ totalm;
	    rlagr[k] = interpolate(i,index,mr,r2,mlagr[k]);
	    k++;
*/
	  }
	}

/*for(i=0;i<n;i++) printf("%e %e %e\n",sqrt(r2[index[i]]),mr[index[i]],rho[index[i]]);*/
/******* calculate central velocity dispersion (rho0,sigma0,rcore0)************/
#ifdef MAKING
	if(1){
	  REAL tmp=0.0;
	  sigma0=0.0;
	  for(i=0;r2[index[i]]<(rlagr[1]*rlagr[1]);i++){
	    REAL v2;
	    v2 = v[index[i]][0]*v[index[i]][0]+v[index[i]][1]*v[index[i]][1]
		+v[index[i]][2]*v[index[i]][2];
	    tmp += m[index[i]];
	    sigma0 += m[index[i]]*v2;
	  }
	  sigma0 /= tmp;
	}

	if(1){
	  REAL tmp=0.0;
	  sigma0=0.0;
/*	  for(i=0;r2[index[i]]<(rlagr[1]*rlagr[1]);i++){*/
	  for(i=0;r2[index[i]]<(rlagr[3]*rlagr[3]);i++){
	    REAL v2;
	    v2 = v[index[i]][0]*v[index[i]][0]+v[index[i]][1]*v[index[i]][1]
		+v[index[i]][2]*v[index[i]][2];
	    tmp += m[index[i]];
	    sigma0 += m[index[i]]*v2;
	  }
	  sigma0 /= tmp;
	}


	rho0 = (3.0/(4.0*PI))* (totalm) * mlagr[0] 
			/ (rlagr[0]*rlagr[0]*rlagr[0]);

	rho0 = (3.0/(4.0*PI))* (totalm) * mlagr[3] 
			/ (rlagr[3]*rlagr[3]*rlagr[3]);

	rcore0 = sqrt(9.0*sigma0/(4.0*PI*rho0));
#endif
/*************** avarage radius for mass bin (rmi[])************/
/*
	for(i=0;i<16;i++){
	  REAL aver;
	  aver = 0.0;
	  for(j=i*(n/16);j<((i+1)*(n/16));j++)aver += sqrt(r2[j]);
	  rmi[i] = aver/(n/16);		        	    	
    	}  
*/
/************* average mass with 10% lagrangean radius (mmean)******/

	if(1){
	  int tmpnum=0;
	  REAL tmpm=0.0,rt2;
/*	  for(i=0;r2[index[i]]<(rlagr[3]*rlagr[3]);i++){*/
	  for(i=0;r2[index[i]]<rcore2;i++){
	    tmpnum++;
	    tmpm += m[index[i]];
	  }
	  mmean = tmpm/(REAL)tmpnum;
	  tmpnum =0;
	  tmpm = 0.0;
	  rt2 = rtidal * rtidal;
	  for(i=0;i<n;i++){
	    if(r2[index[i]]<rt2){
	      tmpnum++;
	      tmpm += m[index[i]];
	    }
	  }
	  mmeant = tmpm/(REAL)tmpnum;
	}

/********* calculate total mass ************************/

	mevl = 0.0;
	for(i=0;i<n;i++) mevl += m[i];

/********* calcualte virial radio with tidal field ****/

/*	force(x,m,epsv,a,pot,n);*/
#ifdef TIDAL_FIELD
/*	force_tidal(x,v,a,n,*totalm,*rtidal,omegag2);*/

        omegag = sqrt(omegag2);
        for(i=0;i<n;i++){
          aco[i][0] =  2.0*omegag*v[i][1];
          aco[i][1] = -2.0*omegag*v[i][0];
          aco[i][2] =  0.0;                   
        }
        for(i=0;i<n;i++){
          ace[i][0] =  3.0*omegag2*x[i][0];
          ace[i][1] =  0.0;
          ace[i][2] =  - omegag2*x[i][2];
        }

#endif
	if(1){
	  REAL rt2,v2,rdotf; 
	  vtermk=vtermv=vtermco=vtermce = 0.0;
	  rt2 = rtidal * rtidal;
	  for(i=0;i<n;i++){
	    int ii;
	    ii = index[i];	
	    if(r2[ii]<rt2){
	      v2 = v[ii][0]*v[ii][0]+v[ii][1]*v[ii][1]+v[ii][2]*v[ii][2];
	      vtermk += 2.0*m[ii]*v2;
	      rdotf = (x[ii][0]-cod[0])*a[ii][0]+(x[ii][1]-cod[1])*a[ii][1]+(x[ii][2]-cod[2])*a[ii][2];
	      vtermv += 2.0*m[ii]*rdotf;
	      rdotf = (x[ii][0]-cod[0])*aco[ii][0]+(x[ii][1]-cod[1])*aco[ii][1]+(x[ii][2]-cod[2])*aco[ii][2];
	      vtermco += 2.0*m[ii]*rdotf;
	      rdotf = (x[ii][0]-cod[0])*ace[ii][0]+(x[ii][1]-cod[1])*ace[ii][1]+(x[ii][2]-cod[2])*ace[ii][2];
	      vtermce += 2.0*m[ii]*rdotf;
	    }
	  }
	  i2dot = vtermk+vtermv+vtermco+vtermce;
	  v_ratio = -vtermk/(vtermv+vtermco+vtermce); 
/*printf("tk,v,co,ce,i2dot,vratio %e %e %e %e %e %e\n",vtermk,vtermv,vtermco,vtermce,i2dot,v_ratio);*/
	}

/******** calculate anisotropy parameter A *******************/

	if(1){
	  REAL rt2,vrad2=0.0,vtan2=0.0,v2,rdotv;
	  rt2 = (rtidal) * (rtidal);
          for(i=0;i<n;i++){
	    int ii;
	    ii = index[i];
	    if(r2[ii]<rt2){
	      REAL tmpvrad2;
	      rdotv = (x[ii][0]-cod[0])*v[ii][0]+(x[ii][1]-cod[1])*v[ii][1]+(x[ii][2]-cod[2])*v[ii][2];
	      tmpvrad2 = rdotv*rdotv/r2[ii];
	      vrad2 += tmpvrad2;
	      v2 = v[ii][0]*v[ii][0]+v[ii][1]*v[ii][1]+v[ii][2]*v[ii][2];
	      vtan2 += v2 - tmpvrad2;
	    }
	  }
	  aniso = 2.0 - vtan2/vrad2;
/*printf("ani vt vr %e %e %e\n",aniso,vtan2,vrad2);*/
	} 	  

/******** calculate angular momentum *******************/
/* (changed x to x-cod 22/7/93) */
	if(1){
	  REAL rt2;
	  amx = amy = amz = 0.0;
	  rt2 = (rtidal) * (rtidal);
          for(i=0;i<n;i++){
	    int ii;
	    ii = index[i];
	    if(r2[ii]<rt2){
	      amx += m[ii]*((x[ii][1]-cod[1])*v[ii][2] - (x[ii][2]-cod[2])*v[ii][1]);
	      amy += m[ii]*((x[ii][2]-cod[2])*v[ii][0] - (x[ii][0]-cod[0])*v[ii][2]);
	      amz += m[ii]*((x[ii][0]-cod[0])*v[ii][1] - (x[ii][1]-cod[1])*v[ii][0]);
	    }
	  }
/*printf("amx y z %e %e %e\n",amx,amy,amz);*/
	} 	  

/******** obtain depth of potential (new) ****************/
        
        if(1){
          REAL pot1=0.0,pot2=0.0,tmpr2;
          for(i=0;i<n;i++){
            tmpr2 = (x[i][0]-cod[0])*(x[i][0]-cod[0])
                  + (x[i][1]-cod[1])*(x[i][1]-cod[1])
                  + (x[i][2]-cod[2])*(x[i][2]-cod[2]);
            pot1 += -m[i]/sqrt(tmpr2);
          }
          potc = pot1;
        }
        
/******** print out *************************/

	fp1 = fopen("radiusdata","a");
	fprintf(fp1,"%e %e %e %e %e ",time,cod[0],cod[1],cod[2],rcore);
	fprintf(fp1,"%e %e %e %e %e ",rlagr[0],rlagr[1],rlagr[2],rlagr[3],rlagr[4]);
	fprintf(fp1,"%e %e %e %e %e ",rlagr[5],rlagr[6],rlagr[7],rlagr[8],rlagr[9]);
	fprintf(fp1,"%e %e %e %e %e %e ",(totalm),mmean,mevl,mmeant,v_ratio,i2dot);
  	fprintf(fp1,"%e %e %e %e ",aniso,amx,amy,amz);
	fprintf(fp1,"%e %e %e %e ",vtermk,vtermv,vtermco,vtermce);
	fprintf(fp1,"%e %e %e %d %e ",rho0,rho0ch,potc,ncore,amz/gyxy);
        fprintf(fp1,"%d %e %d %e \n",ncl,vc2l/ncl,nch,vc2h/nch);

/*	fprintf(fp1,"%e %e %e %d %e %e %e \n",rho0,rho0ch,potc,ncore,vcore,rhodw,rhod2w);
	fprintf(fp1,"%e %e %e %e ",(*totalm),sigma0,rho0,rcore0);
	fprintf(fp1,"%e %e %e %e ",rmi[0],rmi[3],rmi[5],rmi[7]);
	fprintf(fp1,"%e %e %e %e \n",rmi[9],rmi[11],rmi[13],rmi[15]);*/

	fclose(fp1);
}

/*********************************************************************
	make different mass system from equal mass system. 
	assume no-correlation between position and particle number.
	sorting in order mass and quantatization for GRAPE
	dN prop (m^alpha)*dm
*********************************************************************/

double double_rand()
{
	double ranx;
	int k;

	k=rand();
        ranx = 0.5*(1.0+(k-1073741824)/1073741824.0);
	return ranx;
}

void mass_spectle(m,alpha,maxm,n)
REAL m[NMAX];
REAL alpha;
REAL maxm;
int n;
{
	REAL pmax,trial,nm,total_mass=0.0,immean,tmpm=0.0;
	int i; 	

	srand(1);

	if(alpha!=0.0){
	  if(alpha>0.0){
	    pmax=pow(maxm,alpha);
	  }else{
	    pmax=1.0;
	  }
	  for(i=0;i<n;i++){
	    do{
	      m[i]= double_rand()*(maxm-1.0)+1.0;
	      nm = pow(m[i],alpha); 
	      trial = double_rand()*pmax;
/*printf("i %d nm %e trial %e\n",i,nm,trial);*/
	    }while(nm<trial);
	  }
	}
	for(i=0;i<n;i++) total_mass += m[i];
	for(i=0;i<n;i++) m[i] /= total_mass;
	sort_value(0,n-1,m);
/*	for(i=0;i<n;i++) m[i] = ((REAL)anint(m[i]/m[0]*32.0))*m[0]/32.0;*/

	for(i=0;tmpm<0.1;i++){
	  tmpm += m[(n-1)-i];
	}  
	immean = tmpm/(double)i;
	printf("initial mean mass %e\n",immean);

/*	if(1){
	  REAL mrank;
	  int mnum;
	  mrank = m[0];
	  mnum = 1;
	  for(i=1;i<n;i++){
	    if(mrank==m[i]){
	      mnum++;
	    }else{
	      printf("%e %d \n",m[i-1],mnum);
	      mrank = m[i];
	      mnum = 1;		  
	    }
	  }
	  printf("%e %d \n",m[n-1],mnum);
	}
*/
/*for(i=0;i<n;i++)printf("%i %e\n",i,m[i]);
*/
}

#ifdef NOP
/********************************************************
	tidal field of galaxies.
	  galactic centre is at (-Rg,0,0) 
	  tidal radius: rt \sim (M/3Mg)^(1/3)Rg
	  angular speed: omegag \sim (GM/3rt^3)^(1/2) 
*********************************************************/
void force_tidal(x,v,a,n,totalm,rtidal,omegag2)
        REAL x[NMAX][DIM];
        REAL v[NMAX][DIM]; 
        REAL a[NMAX][DIM];
	int n;
	REAL totalm,rtidal,omegag2;
{
/*	REAL omegag2,omegag;*/
	REAL omegag;
	int i;

/*	omegag2 = totalm/(3.0*rtidal*rtidal*rtidal);*/
	omegag = sqrt(omegag2);	

	for(i=0;i<n;i++){
	  a[i][0] +=  2.0*omegag*v[i][1] + 3.0*omegag2*x[i][0];
	  a[i][1] += -2.0*omegag*v[i][0];
	  a[i][2] += 			 - omegag2*x[i][2];
	}

/*printf("omega,omega2 = %22.15e %22.15e\n",omegag,omegag2);*/
}

#endif





