/*
 * GGETPUT.c  : utility routine for screendump on MS-DOS
 *              (NEC-PC & J-3100)
 *
 * Jun Makino 	89/09/25 coding stated
 *	      	89/09/27 "Expand" function added
 *
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <memory.h>
union REGS inregs, outregs;
struct SREGS segs;

unsigned int bitexpand();
unsigned int bitexpand(ch)
unsigned char ch;
{
	unsigned int tmp,c,swap;
	unsigned int i,j,k;
	tmp = 0;
	c=ch;
	k=3;
	for(i=0;i<8;i++){
		if(c %2){
			tmp |= k;
		}
		c>>=1;
		k<<=2;
	}
	swab((char*)&tmp,(char*)&swap,2);
	return swap;
}
static unsigned int bitexpandtable[256];
void set_bitexpandtable()
{
	unsigned int i;
	for(i=0;i<256;i++){
		bitexpandtable[i]=bitexpand((unsigned char)i);
	}
}
static void set_cursor(start,end)
int  start;		/* cursor start raster */
int  end;		/* cursor end raster */
{
	inregs.h.ah = 1;
        inregs.h.ch = start & 0xf;
        inregs.h.cl = end & 0xf;
    	int86(0x10,&inregs,&outregs);
}

static void cursor_on()
{
	set_cursor(0,15);
}

static void cursor_off()
{
	set_cursor(1,0);
}


static void j3100_read_start_address(goff, toff)
int * goff;		/* graphic offset*/
int * toff;		/* text offset */
{
	inregs.h.ah = 15;
	int86(0x10,&inregs,&outregs);
	inregs.h.ah=131;
	inregs.h.al = outregs.h.bh;
	*goff = outregs.x.ax;
	*toff = outregs.x.bx;
}

void window_getput(x1,y1,x2,y2, save_array, mode,cmode)
unsigned int x1, y1, x2, y2;/* window coordinates (text)*/
char save_array[];
int mode;		/* 0: get, 1:put*/
int cmode;		/* 0: monochrome 1: color */
{
	unsigned int soseg, sooff, deseg, deoff, size;
	unsigned int gbase, tmp;
	unsigned int i,j, xaddress;
	int ipage, pages;
	char * ptr;
#ifdef LARGE_MODEL
	ptr = (char *) save_array;
	deseg = FP_SEG(ptr);
	deoff = FP_OFF(ptr);
#else /* SMALL_MODEL*/
	segread(&segs);
	deseg = segs.ds;
	deoff = (unsigned int) save_array;
#endif
#ifdef J3100
	soseg = 0xb800;
	j3100_read_start_address(&gbase, &tmp);
	gbase=0;	/* something strange */
#define XFORMULA (((x1+(i/4)*80+gbase)%0x2000)+((i&3)*0x2000))
#define COLOR_CAPACITY 0
#endif
#ifdef PC98
	soseg = 0xa800;	
#define XFORMULA (x1+i*80)
#define COLOR_CAPACITY 1
#endif

	y1= y1*16;
	y2= (y2 + 1)*16;
	if(y2>400)y2=400;
	size = x2-x1+1;
	if(cmode && COLOR_CAPACITY){
		pages=3;
	}else{
		pages=1;
	}
	for(ipage=0;ipage<pages;ipage++){
		if(mode==0){
			for(i=y1; i<y2; i++){
				xaddress= XFORMULA;
				movedata(soseg,xaddress, deseg, deoff, size);
				deoff += size;
			}
		}else{
			for(i=y1; i<y2; i++){
				xaddress= XFORMULA;
				movedata(deseg, deoff,soseg,xaddress,size);
				deoff += size;
			}
		}
		soseg += 0x0800;
	}
/*	printf("gbase = %4x\n", gbase);
	printf("tbase = %4x\n", tmp);*/
}

int window_get_file(rasterfile,x1,y1,x2,y2, save_array, cmode)
FILE *rasterfile;
unsigned int *x1, *y1, *x2, *y2;/* window coordinates (text)*/
char save_array[];
int *cmode;		/* 0: monochrome 1: color */
{
	int length;
	if(fread((char *)x1 ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fread((char *)y1 ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fread((char *)x2 ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fread((char *)y2 ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fread((char *)cmode ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fread((char *)&length ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fread((char *)save_array,length,2,rasterfile) != 2)return 1;
	return 0;
}
int window_put_file(rasterfile,x1,y1,x2,y2, save_array, cmode)
FILE *rasterfile;
unsigned int *x1, *y1, *x2, *y2;/* window coordinates (text)*/
char save_array[];
int *cmode;		/* 0: monochrome 1: color */
{
	int length;
	length=((*x2)-(*x1)+1)*((*y2)-(*y1)+1)*8;
	printf("(window put file) header data: %d %d %d %d %d %d\n",
		*x1,*y1,*x2,*y2,*cmode,length);
	if(fwrite((char *)x1 ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fwrite((char *)y1 ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fwrite((char *)x2 ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fwrite((char *)y2 ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fwrite((char *)cmode ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fwrite((char *)&length ,sizeof(*x1),1,rasterfile) != 1)return 1;
	if(fwrite((char *)save_array,length,2,rasterfile) != 2)return 1;
	return 0;
}

void window_reverse(x1,y1,x2,y2, save_array, cmode)
unsigned int x1, y1, x2, y2;/* window coordinates (text)*/
char *  save_array;
int cmode;		/* 0: monochrome 1: color */
{
	int i,length;
	unsigned int * ptr;
	if(cmode){
		cmode=3;
	}else{
		cmode=1;
	}
	length=((x2)-(x1)+1)*((y2)-(y1)+1)*8*cmode;
	ptr = (unsigned int *) save_array;
	for(i=0; i<length; i++, ptr++) *ptr = ~*ptr;
}

void window_expand(x1,y1,x2,y2, raster_array, work_array, cmode)
unsigned int x1, y1, x2, y2;/* window coordinates (text)*/
char *  raster_array;
unsigned int * work_array;
int cmode;		/* 0: monochrome 1: color */
{
	int i,length;
	unsigned char * sptr;
	unsigned int * dptr;
	int page, iy, ix;
	int yl1,yl2,wx;
	set_bitexpandtable();
	wx = x2-x1+1;
	yl1 = y1*16;
	yl2 = (y2+1)*16;
	if(cmode){
		cmode=3;
	}else{
		cmode=1;
	}
	sptr = raster_array;
	dptr = work_array;
	for(page=0;page<cmode;page++){
		for(iy=yl1;iy<yl2; iy++){
			for(ix=x1;ix<=x2; ix++){
				*dptr = bitexpandtable[(unsigned int)(*sptr)];
				dptr++;
				sptr++;
			}
			memcpy((char*)dptr,(char*)(dptr-wx),wx*2);
			dptr+=wx;
		}
	}
	length=((x2)-(x1)+1)*((y2)-(y1)+1)*16*cmode*4;
	memcpy(raster_array,work_array,length);
}


#ifdef TEST
double internal_time();
int screen_data[4096];
int screen_data1[4096];
int screen_data2[4096];
int screen_data3[4096];
main()
{
	long t1,t2;
	int i,j;
	double tnow;
	ginit();
	screen(2,0,0,1);
	for(j=0;j<1; j++){
		for(i=0; i<399; i++){
			pset(i,i,1);
		}	
	}
	window_getput(0,0,31,15,screen_data3,0,0);
	memset(screen_data,(char) 0x0f,8192);
	memset(screen_data1,(char) 0xf0,8192);
	memset(screen_data2,(char) 0x0,8192);
	cursor_off();
	window_getput(0,0,31,15,screen_data,1,0);
	window_getput(0,0,31,15,screen_data,1,0);
	window_getput(0,0,31,15,screen_data,1,0);

	window_getput(0,0,31,15,screen_data1,1,0);
	window_getput(0,0,31,15,screen_data1,1,0);
	window_getput(0,0,31,15,screen_data1,1,0);

	window_getput(0,0,31,15,screen_data2,1,0);
	window_getput(0,0,31,15,screen_data2,1,0);
	window_getput(0,0,31,15,screen_data2,1,0);

	window_getput(0,0,31,15,screen_data3,1,0);
	window_getput(0,0,31,15,screen_data3,1,0);
	window_getput(0,0,31,15,screen_data3,1,0);
	for(i=0;i<100; i++){
		window_getput(0,0,31,15,screen_data1,1,0);
		window_getput(0,0,31,15,screen_data3,1,0);
	}
	screen(3,0,0,1);
	ginit();
	cls();
}
#endif
